org.apache.poi.sl.extractor

## Class SlideShowExtractor<S extends Shape<S,P>,P extends TextParagraph<S,P,? extends TextRun>>

- java.lang.Object
- - org.apache.poi.extractor.POITextExtractor
  - - org.apache.poi.sl.extractor.SlideShowExtractor<S,P>

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class SlideShowExtractor<S extends Shape<S,P>,P extends TextParagraph<S,P,? extends TextRun>>
      extends POITextExtractor

  Common SlideShow extractor
  Since:
    POI 4.0.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SlideShowExtractor(SlideShow<S,P> slideshow)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.BitSet` | `getCodepoints(java.lang.String typeface, java.lang.Boolean italic, java.lang.Boolean bold)` Deprecated. use `getCodepointsInSparseBitSet(String, Boolean, Boolean)`
    `com.zaxxer.sparsebits.SparseBitSet` | `getCodepointsInSparseBitSet(java.lang.String typeface, java.lang.Boolean italic, java.lang.Boolean bold)` Extract the used codepoints for font embedding / subsetting
    `java.lang.Object` | `getDocument()` Returns opened document
    `POITextExtractor` | `getMetadataTextExtractor()` Returns another text extractor, which is able to output the textual content of the document metadata / properties, such as author and title.
    `java.util.List<? extends ObjectShape<S,P>>` | `getOLEShapes()`
    `java.lang.String` | `getText()` Fetches all the slide text from the slideshow, but not the notes, unless you've called setSlidesByDefault() and setNotesByDefault() to change this
    `java.lang.String` | `getText(Slide<S,P> slide)`
    `void` | `setCommentsByDefault(boolean commentsByDefault)` Should a call to getText() return comments text? Default is no
    `void` | `setMasterByDefault(boolean masterByDefault)` Should a call to getText() return text from master? Default is no
    `void` | `setNotesByDefault(boolean notesByDefault)` Should a call to getText() return notes text? Default is no
    `void` | `setSlidesByDefault(boolean slidesByDefault)` Should a call to getText() return slide text? Default is yes

    - ### Methods inherited from class org.apache.poi.extractor.POITextExtractor

      `close, setFilesystem`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SlideShowExtractor

          public SlideShowExtractor(SlideShow<S,P> slideshow)

  - ### Method Detail

    - #### getDocument

          public final java.lang.Object getDocument()

      Returns opened document
      Specified by:
        `getDocument` in class `POITextExtractor`
      Returns:
        the opened document

    - #### setSlidesByDefault

          public void setSlidesByDefault(boolean slidesByDefault)

      Should a call to getText() return slide text? Default is yes

    - #### setNotesByDefault

          public void setNotesByDefault(boolean notesByDefault)

      Should a call to getText() return notes text? Default is no

    - #### setCommentsByDefault

          public void setCommentsByDefault(boolean commentsByDefault)

      Should a call to getText() return comments text? Default is no

    - #### setMasterByDefault

          public void setMasterByDefault(boolean masterByDefault)

      Should a call to getText() return text from master? Default is no

    - #### getMetadataTextExtractor

          public POITextExtractor getMetadataTextExtractor()

      Description copied from class: `POITextExtractor`
      Returns another text extractor, which is able to output the textual content of the document metadata / properties, such as author and title.
      Specified by:
        `getMetadataTextExtractor` in class `POITextExtractor`
      Returns:
        the metadata and text extractor

    - #### getText

          public java.lang.String getText()

      Fetches all the slide text from the slideshow, but not the notes, unless you've called setSlidesByDefault() and setNotesByDefault() to change this
      Specified by:
        `getText` in class `POITextExtractor`
      Returns:
        All the text from the document

    - #### getText

          public java.lang.String getText(Slide<S,P> slide)

    - #### getOLEShapes

          public java.util.List<? extends ObjectShape<S,P>> getOLEShapes()

    - #### getCodepoints

          @Deprecated
          public java.util.BitSet getCodepoints(java.lang.String typeface,
                                                            java.lang.Boolean italic,
                                                            java.lang.Boolean bold)

      Deprecated. use `getCodepointsInSparseBitSet(String, Boolean, Boolean)`
      Extract the used codepoints for font embedding / subsetting
      Parameters:
        `typeface` - the typeface/font family of the textruns to examine
        `italic` - use `true` for italic TextRuns, `false` for non-italic ones and `null` if it doesn't matter
        `bold` - use `true` for bold TextRuns, `false` for non-bold ones and `null` if it doesn't matter
      Returns:
        a bitset with the marked/used codepoints

    - #### getCodepointsInSparseBitSet

          public com.zaxxer.sparsebits.SparseBitSet getCodepointsInSparseBitSet(java.lang.String typeface,
                                                                                java.lang.Boolean italic,
                                                                                java.lang.Boolean bold)

      Extract the used codepoints for font embedding / subsetting
      Parameters:
        `typeface` - the typeface/font family of the textruns to examine
        `italic` - use `true` for italic TextRuns, `false` for non-italic ones and `null` if it doesn't matter
        `bold` - use `true` for bold TextRuns, `false` for non-bold ones and `null` if it doesn't matter
      Returns:
        a bitset with the marked/used codepoints

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.